## magics++ 3.0.3

=== debian/changelog ===
magics++ (3.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Apr 2018 06:38:09 +0100

magics++ (3.0.2-1) unstable; urgency=medium

  * New upstream release
  * Drop obsolete --parallel for dh 

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 17 Mar 2018 07:58:25 +0000

magics++ (3.0.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.3; no changes required
  * Move the Vcs over to salsa.debian.org
  * Remove obsolete patches from source:
    - numpy_fix.patch
    - python3 patch
    - python-type-fix.patch
  * Add lintian-overrides for erroneous missing-source reports
  * Add Apache NOTICE file to libmagics++-dev.docs

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Mar 2018 12:32:13 +0000

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 10) , 
 dh-buildinfo, 
 gfortran, 
 cmake, 
 chrpath,
 dh-python,  swig,
 python-dev, python-numpy, 
 python3-dev, python3-numpy,
 python-jinja2,
 python3-jinja2,
 libhdf5-dev | libhdf5-mpi-dev, 
 libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libodb-api-dev (>= 0.17.4-3),
 libeccodes-dev | libgrib-api-dev (>= 1.14.5-2), 
 libeccodes-tools | libgrib-api-tools, 
 libemos-bin, 
 libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 ttf-dejavu-core, 
 libxml-parser-perl, 
 ghostscript, 
 zlib1g-dev, 
 libboost-dev | libboost1.63-dev, 
 libproj-dev, 
 qtbase5-dev-tools, 
 qtbase5-dev, 
 qt5-qmake
Standards-Version: 4.1.3
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Browser: https://salsa.debian.org:/science-team/magics.git
Vcs-Git: https://salsa.debian.org:/science-team/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, 
 libterralib-dev, magics++, libodb-api-dev
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, 
 python, python-simplejson, python-jinja2
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: python3-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, 
 python3-simplejson, python3-jinja2
Description: Python3 support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides Python3 support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with python2,python3 --with-buildsystem=cmake

# To fix cmake output change these
OLD_GF_PATH=$(shell gfortran -print-search-dirs | grep install | cut -f2 -d' '  )libgfortran.so
NEW_GF_PATH:=$(LIBDIR)/libgfortran.so.4

# -DCMAKE_PREFIX_PATH=${LIBDIR}/cmake/grib_api \

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DHAVE_ODB=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	rm -rf debian/build-py*
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build src/boost
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	       	$(extra_flags) 
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
	       	$(extra_flags) 
	(cd python/Magics && ln -s $(CURDIR)/debian/build-py3/python/Magics/Magics.i )

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py2/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py2  check )
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	(cd  debian/build-py2/python && python2 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	(cd  debian/build-py3/python && python3 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	dh_auto_install --builddirectory=debian/build-py3
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
	| sed -e 's%$(OLD_GF_PATH)%$(NEW_GF_PATH)%'   \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_python3 /usr/lib/python3*/site-packages/Magics
	dh_numpy -p python-magics++
	dh_numpy3 -p python3-magics++
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_makeshlibs:
	# For new symbols when compiled with GCC 7
	dh_makeshlibs -V'libmagplus3v5 (>= 2.34.1-2~)'

override_dh_fixperms-arch:
	dh_fixperms
	find debian/tmp debian/python*-magics++   -name '*.so*' -exec chrpath -d {} \;

## magics++ 3.0.4

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF

# Missing dependencies:
#   * ghostscript ( is it really needed? -- to confirm )

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.6 )

###############################################################################
# some variables of this project

set(ECCODES_FAIL_MSG "Note: grib_api can be used instead (select with -DENABLE_ECCODES=OFF), "
                      "but we strongly advise you to upgrade to ecCodes. "
                      "See https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home\n"
                      )

ecbuild_add_option( FEATURE ECCODES DESCRIPTION "Use eccodes instead of grib_api"
                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 0.14 REQUIRED FAILURE_MSG ECCODES_FAIL_MSG"
                    DEFAULT ON )

if( HAVE_ECCODES)
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
  set( grib_handling_pkg eccodes )
else()
  ecbuild_use_package( PROJECT grib_api VERSION 1.14.3 REQUIRED
                       FAILURE_MSG "ecCodes can be used instead (enable with -DENABLE_ECCODES=ON)" )
  set( grib_handling_pkg grib_api )
endif()


# grib_api is required for now
set( HAVE_GRIB 1 )

ecbuild_add_option( FEATURE BUFR
                    DEFAULT ON
                    DESCRIPTION "BUFR support"
                    REQUIRED_PACKAGES "PROJECT libemos VERSION 4.0.5" )

ecbuild_add_option( FEATURE ODB
                    DEFAULT ON
                    DESCRIPTION "ODB support"
                    REQUIRED_PACKAGES "PROJECT odb_api VERSION 0.10.2")
					#	"PROJECT eckit   VERSION 0.9.0" )

ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo Pango PNG)

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C" )

ecbuild_add_option( FEATURE SPOT
                    DEFAULT OFF
                    DESCRIPTION "enable spot support"
                    REQUIRED_PACKAGES "PROJECT spot" )

ecbuild_add_option( FEATURE PYTHON
                    DEFAULT ON
                    DESCRIPTION "enable python interface"
                    REQUIRED_PACKAGES "Python NO_LIBS" NumPy )

ecbuild_add_option( FEATURE FORTRAN
                    DEFAULT ON
                    DESCRIPTION "enable Fortran interface" )

if( HAVE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE QT5
                    DEFAULT ON
                    DESCRIPTION "use Qt5 instead of version 4" )

option( BUILD_SHARED_LIBS  "Set to BOTH to build static library in addition to shared"  ON )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

set( MAGICS_REFERENCE_VERSIONS            "3.0.0" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_CURRENT_BINARY_DIR}/python )

###############################################################################
# projects

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

#ecbuild_add_cxx_flags("-gdwarf-2")
ecbuild_add_c_flags("-std=c99")

### Metview and Qt
ecbuild_info("TESTING for Metview and Qt ...")

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    ecbuild_info("TESTING for Metview ...")
    unset(MAGICS_ONLY)

    if( HAVE_QT5 )
      find_package(Qt5Widgets REQUIRED)
      if( Qt5Widgets_FOUND )
          ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
          include_directories(${Qt5Widgets_INCLUDE_DIRS})
          set( MAGICS_QT 1)
          set( MAGICS_QT5 1)
          set( qt yes)
          add_definitions( -DMAGICS_QT5 )
      else()
          ecbuild_critical("Qt5 was NOT found ...")
      endif()
    else( HAVE_QT5 )
      find_package(Qt4 4.6.2 REQUIRED QtCore QtGui QtXml )
      if( QT_FOUND )
		    include( ${QT_USE_FILE} )
		    set( MAGICS_QT 1)
		    set( qt yes)
      endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads )

# set(Boost_USE_STATIC_LIBS        ON)
# set(Boost_NO_SYSTEM_PATHS        ON)
# set(Boost_USE_MULTITHREADED      ON)
#ecbuild_add_extra_search_paths( boost )

find_package( Boost 1.53.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT REQUIRED )

###############################################################################
# contents

set( MAGICS_TPLS grib_api spot EXPAT NetCDF Proj4 libemos )

set( MAGICS_INCLUDE_DIRS
     ${CMAKE_CURRENT_SOURCE_DIR}/src
     ${CMAKE_BINARY_SOURCE_DIR}/src
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
     ${CMAKE_CURRENT_BINARY_DIR}/src/params
     ${CMAKE_CURRENT_BINARY_DIR}/src
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
     ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
     ${CMAKE_CURRENT_SOURCE_DIR}/src/web
     ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
     ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
     ${CMAKE_CURRENT_SOURCE_DIR}/src/libMagWrapper
     ${Boost_INCLUDE_DIRS} )

if( HAVE_CAIRO )
  list( APPEND MAGICS_TPLS PangoCairo PNG PANGO)
  list( APPEND MAGICS_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS} )
endif()

if( HAVE_ODB )
  list( APPEND MAGICS_TPLS odb_api )
  list( APPEND MAGICS_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/oda
        ${ODB_API_INCLUDE_DIRS}
		${ECKIT_INCLUDE_DIRS} )
endif()

set( MAGICS_LIBRARIES    MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( NOT ${TPL} STREQUAL "LIBEMOS" ) # don't add libemos definitions
    list( APPEND MAGICS_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    endif()
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    string(REGEX REPLACE "[ ]+$" "" ${TPL}_LIBRARIES "${${TPL}_LIBRARIES}") # strips leading whitespaces
    string(REGEX REPLACE "^[ ]+" "" ${TPL}_LIBRARIES "${${TPL}_LIBRARIES}") # strips trailing whitespaces
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
    ecbuild_info("${TPL}_LIBRARIES [${${TPL}_LIBRARIES}]") # add this to confirm that indeed it was cleaned up
endforeach()

if( HAVE_BUFR )
	list( APPEND MAGICS_EXTRA_DEFINITIONS   fortfloat=double fortint=int )
endif()
if( WITH_QT_DEBUG )
	list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
endif()

if( MAGICS_QT )
  if( MAGICS_QT5 )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )
  else()
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${QT_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES     ${QT_LIBRARIES} )
endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
  list( APPEND MAGICS_EXTRA_DEFINITIONS HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )

# scripts
add_subdirectory( tools )

# source files
add_subdirectory( src )

# shared files
add_subdirectory( share )

# python interface
add_subdirectory( python )

# apps directory
add_subdirectory( apps )

# Test directory
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources
		DONT_PACK_DIRS tools/versioncmp
		tools/regression
		regression
		docs
		toolsjs
		notebook
		test/old
		tools/xml
		tools/use_scripts
		tools/versioncmp_folders)

ecbuild_add_resources( TARGET internal
		DONT_PACK configure.lxab
		configure.local
		configure.ecgb
		configure.ecmwf
)

############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/wiki/display/MAGP/Magics" )
ecbuild_pkgconfig()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== test/CMakeLists.txt ===
set( grib_environment
    GRIB_DEFINITION_PATH=${grib_api_BASE_DIR}/share/${grib_handling_pkg}/definitions
    GRIB_SAMPLES_PATH=${grib_api_BASE_DIR}/share/${grib_handling_pkg}/samples )
    
# Basic test 
ecbuild_add_test( TARGET basic_c
                  SOURCES   coast.c
                  LIBS      MagPlusSingle MagPlus
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE C )

ecbuild_add_test( TARGET basic_python
                  TYPE PYTHON
                  CONDITION HAVE_PYTHON
                  ARGS coast.py
                  RESOURCES coast.py 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET basic_fortran_shared
                  SOURCES   coast.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET basic_fortran_static
                  SOURCES   coast.f90
                  LIBS      MagPlusSingleStatic MagPlusStatic ${MAGICS_EXTRA_LIBRARIES} 
                  CONDITION HAVE_FORTRAN AND BUILD_SHARED_LIBS STREQUAL "BOTH"
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )       

ecbuild_add_test( TARGET bufr_python
                  TYPE PYTHON
                  CONDITION HAVE_BUFR AND HAVE_PYTHON
                  ARGS bufr.py
                  RESOURCES bufr.py data.bufr 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET bufr_fortran
                  SOURCES   bufr.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_BUFR AND HAVE_FORTRAN
                  RESOURCES data.bufr
                  LINKER_LANGUAGE Fortran 
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..)

ecbuild_add_test( TARGET bufr_fortran_static
                  SOURCES   bufr.f90
                  RESOURCES data.bufr
                  LIBS      MagPlusSingleStatic MagPlusStatic
                  CONDITION HAVE_BUFR AND HAVE_FORTRAN AND BUILD_SHARED_LIBS STREQUAL "BOTH"
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )       

ecbuild_add_test( TARGET grib_python
                  TYPE PYTHON
                  CONDITION HAVE_GRIB AND HAVE_PYTHON
                  ARGS grib.py
                  RESOURCES grib.py data.grib
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                              ${grib_environment} )

ecbuild_add_test( TARGET grib_fortran
                  SOURCES   grib.f90
                  LIBS      MagPlusSingle MagPlus
                  RESOURCES data.grib
                  CONDITION HAVE_GRIB AND HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  ${grib_environment}
                  LINKER_LANGUAGE Fortran 
                  )

ecbuild_add_test( TARGET cairo_python
                  TYPE PYTHON
                  CONDITION HAVE_CAIRO AND HAVE_PYTHON
                  ARGS cairo.py
                  RESOURCES cairo.py 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET cairo_fortran
                  SOURCES   cairo.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_CAIRO AND HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET odb_python
                  TYPE PYTHON
                  CONDITION HAVE_ODB AND HAVE_PYTHON
                  ARGS odb.py
                  RESOURCES odb.py test.odb
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

=== src/decoders/CMakeLists.txt ===
set( _decoders_srcs
BinningObject.cc
BinningObject.h
BoxPlotDecoder.cc
BoxPlotDecoder.h
Date.cc
DateTime.cc
DateTime.h
EfiLegendEntry.h
EpsXmlInput.cc
EpsXmlInput.h
GeoPointsDecoder.cc
GeoPointsDecoder.h
ImportAction.h
InputData.cc
InputData.h
InputMatrix.cc
InputMatrix.h
InputMatrixInterpretor.cc
InputMatrixInterpretor.h
LandgramDecoder.cc
LandgramDecoder.h
LocalTable.cc
LocalTable.h
MapGenDecoder.cc
MapGenDecoder.h
MatrixTestDecoder.cc
MatrixTestDecoder.h
ObsStatDecoder.cc
ObsStatDecoder.h
ShapeDecoder.cc
ShapeDecoder.h
SimplePolylineInput.cc
SimplePolylineInput.h
SymbolInput.h
TableDecoder.cc
TableDecoder.h
ThinningMethod.cc
ThinningMethod.h
Time.cc
TitleField.cc
TitleField.h
TitleMetaField.cc
TitleMetaField.h
TitleStringField.cc
TitleStringField.h
TitleTemplate.cc
TitleTemplate.h
WindMode.cc
WindMode.h
XYList.cc
XYList.h
shapefil.h
shpopen.c
dbfopen.c
safileio.c
)

foreach( file ${_decoders_srcs} )
  list( APPEND decoders_srcs decoders/${file} )
endforeach()

if (HAVE_GRIB)
     list( APPEND decoders_srcs 
decoders/GribAddressMode.h
decoders/GribDecoder.cc
decoders/GribDecoder.h
decoders/GribInterpretor.h
decoders/GribLoopStep.cc
decoders/GribLoopStep.h
decoders/GribRegularInterpretor.cc
decoders/GribRegularInterpretor.h
decoders/GribSatelliteInterpretor.cc
decoders/GribSatelliteInterpretor.h
)
endif()


if (HAVE_NETCDF) 
     list( APPEND decoders_srcs 
#Netcdf--->
decoders/NetcdfOrcaInterpretor.cc
decoders/NetcdfData.cc
decoders/NetcdfData.h
decoders/NetcdfConvention.cc
decoders/NetcdfConvention.h
decoders/NetcdfDecoder.cc
decoders/NetcdfDecoder.h
decoders/NetcdfGeoMatrixInterpretor.cc
decoders/NetcdfGeoMatrixInterpretor.h
decoders/NetcdfGeopointsInterpretor.cc
decoders/NetcdfGeopointsInterpretor.h
decoders/NetcdfInterpretor.cc
decoders/NetcdfInterpretor.h
decoders/NetcdfMarsConvention.cc
decoders/NetcdfMarsConvention.h
decoders/NetcdfMatrixInterpretor.cc
decoders/NetcdfMatrixInterpretor.h
decoders/NetcdfOrcaInterpretor.h
decoders/NetcdfVectorInterpretor.cc
decoders/NetcdfVectorInterpretor.h
#<----Netcdf
)
endif()

if (HAVE_BUFR)
     list( APPEND decoders_srcs 
# Bufr --->
decoders/EpsBufr.cc
decoders/EpsBufr.h
decoders/ObsDecoder.cc
decoders/ObsDecoder.h
# <--- Bufr
)

endif()


if (HAVE_SPOT)
     list( APPEND decoders_srcs 
#Spot ---> 
decoders/ClassicMtgDecoder.cc
decoders/ClassicMtgDecoder.h
decoders/EpsgramDecoder.cc
decoders/EpsgramDecoder.h
#<--- Spot  
)
endif()

set( decoders_srcs ${decoders_srcs} PARENT_SCOPE )

if ( metview )
	list (APPEND metview_include 
			decoders/DateTime.h 
			decoders/GribDecoder.h 
			decoders/ThinningMethod.h 
			decoders/BinningObject.h  
			decoders/WindMode.h  
			decoders/GribAddressMode.h  
			decoders/GribLoopStep.h  
			decoders/GribInterpretor.h
			decoders/GribSatelliteInterpretor.h
			
			)
	set( metview_include ${metview_include} PARENT_SCOPE )
endif()
